## cppcheck 2.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)
project(Cppcheck)

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

include(GNUInstallDirs)

include(cmake/versions.cmake)
include(cmake/options.cmake)
include(cmake/findDependencies.cmake)
include(cmake/compileroptions.cmake)
include(cmake/compilerDefinitions.cmake)
include(cmake/buildFiles.cmake)
include(cmake/cxx11.cmake)

use_cxx11()

file(GLOB addons "addons/*.py")
file(GLOB cfgs "cfg/*.cfg")
file(GLOB platforms "platforms/*.xml")

if (BUILD_TESTS)
    enable_testing()
endif()

add_subdirectory(externals/tinyxml)
add_subdirectory(externals/simplecpp)
add_subdirectory(lib)   # CppCheck Library 
add_subdirectory(cli)   # Client application
add_subdirectory(test)  # Tests
ADD_SUBDIRECTORY(gui)   # Graphical application
ADD_SUBDIRECTORY(tools/triage)   # Triage tool
add_subdirectory(oss-fuzz) # OSS-Fuzz clients

include(cmake/printInfo.cmake)
include(cmake/clang_tidy.cmake)

=== Makefile ===
# This file is generated by tools/dmake, do not edit.

# To compile with rules, use 'make HAVE_RULES=yes'
ifndef HAVE_RULES
    HAVE_RULES=no
endif

ifndef USE_Z3
    USE_Z3=no
endif

ifeq ($(USE_Z3),yes)
    CPPFLAGS += -DUSE_Z3
    LIBS += -lz3
endif
# use match compiler
ifeq ($(SRCDIR),build)
    $(warning Usage of SRCDIR to activate match compiler is deprecated. Use MATCHCOMPILER=yes instead.)
    MATCHCOMPILER:=yes
endif
ifeq ($(MATCHCOMPILER),yes)
    # Find available Python interpreter
    PYTHON_INTERPRETER := $(shell which python)
    ifndef PYTHON_INTERPRETER
        PYTHON_INTERPRETER := $(shell which python3)
    endif
    ifndef PYTHON_INTERPRETER
        $(error Did not find a Python interpreter)
    endif
    ifdef VERIFY
        matchcompiler_S := $(shell $(PYTHON_INTERPRETER) tools/matchcompiler.py --verify)
    else
        matchcompiler_S := $(shell $(PYTHON_INTERPRETER) tools/matchcompiler.py)
    endif
    libcppdir:=build
else
    libcppdir:=lib
endif

ifdef FILESDIR
    CPPFILESDIR=-DFILESDIR=\"$(FILESDIR)\"
else
    CPPFILESDIR=
endif

RDYNAMIC=-rdynamic
# Set the CPPCHK_GLIBCXX_DEBUG flag. This flag is not used in release Makefiles.
# The _GLIBCXX_DEBUG define doesn't work in Cygwin or other Win32 systems.
ifndef COMSPEC
    ifdef ComSpec
        #### ComSpec is defined on some WIN32's.
        COMSPEC=$(ComSpec)
    endif # ComSpec
endif # COMSPEC

ifdef COMSPEC
    #### Maybe Windows
    ifndef CPPCHK_GLIBCXX_DEBUG
        CPPCHK_GLIBCXX_DEBUG=
    endif # !CPPCHK_GLIBCXX_DEBUG

    ifeq ($(MSYSTEM),MINGW32 MINGW64)
        LDFLAGS=-lshlwapi
    else
        RDYNAMIC=-lshlwapi
    endif
else # !COMSPEC
    uname_S := $(shell sh -c 'uname -s 2>/dev/null || echo not')

    ifeq ($(uname_S),Linux)
        ifndef CPPCHK_GLIBCXX_DEBUG
            CPPCHK_GLIBCXX_DEBUG=-D_GLIBCXX_DEBUG
        endif # !CPPCHK_GLIBCXX_DEBUG
    endif # Linux

    ifeq ($(uname_S),GNU/kFreeBSD)
        ifndef CPPCHK_GLIBCXX_DEBUG
            CPPCHK_GLIBCXX_DEBUG=-D_GLIBCXX_DEBUG
        endif # !CPPCHK_GLIBCXX_DEBUG
    endif # GNU/kFreeBSD

endif # COMSPEC

# Set the UNDEF_STRICT_ANSI flag to address compile time warnings
# with tinyxml2 and Cygwin.
ifdef COMSPEC
    uname_S := $(shell uname -s)

    ifneq (,$(findstring CYGWIN,$(uname_S)))
        UNDEF_STRICT_ANSI=-U__STRICT_ANSI__
    endif # CYGWIN
endif # COMSPEC

ifndef CXX
    CXX=g++
endif

ifeq (clang++, $(findstring clang++,$(CXX)))
    CPPCHK_GLIBCXX_DEBUG=
endif
ifndef CXXFLAGS
    CXXFLAGS=-std=c++0x -O2 -DNDEBUG -Wall -Wno-sign-compare
endif

# Increase stack size for Cygwin builds to avoid segmentation fault in limited recursive tests.
ifdef COMSPEC
    uname_S := $(shell uname -s)

    ifneq (,$(findstring CYGWIN,$(uname_S)))
        CXXFLAGS+=-Wl,--stack,8388608
    endif # CYGWIN
endif # COMSPEC

ifeq (g++, $(findstring g++,$(CXX)))
    override CXXFLAGS += -std=c++0x
else ifeq (clang++, $(findstring clang++,$(CXX)))
    override CXXFLAGS += -std=c++0x
else ifeq ($(CXX), c++)
    ifeq ($(shell uname -s), Darwin)
        override CXXFLAGS += -std=c++0x
    endif
endif

ifeq ($(HAVE_RULES),yes)
    override CXXFLAGS += -DHAVE_RULES -DTIXML_USE_STL $(shell pcre-config --cflags)
    ifdef LIBS
        LIBS += $(shell pcre-config --libs)
    else
        LIBS=$(shell pcre-config --libs)
    endif
endif

ifndef PREFIX
    PREFIX=/usr
endif

ifndef INCLUDE_FOR_LIB
    INCLUDE_FOR_LIB=-Ilib -isystem externals -isystem externals/simplecpp -isystem externals/tinyxml
endif

ifndef INCLUDE_FOR_CLI
    INCLUDE_FOR_CLI=-Ilib -isystem externals/simplecpp -isystem externals/tinyxml
endif

ifndef INCLUDE_FOR_TEST
    INCLUDE_FOR_TEST=-Ilib -Icli -isystem externals/simplecpp -isystem externals/tinyxml
endif

BIN=$(DESTDIR)$(PREFIX)/bin

# For 'make man': sudo apt-get install xsltproc docbook-xsl docbook-xml on Linux
DB2MAN?=/usr/share/sgml/docbook/stylesheet/xsl/nwalsh/manpages/docbook.xsl
XP=xsltproc -''-nonet -''-param man.charmap.use.subset "0"
MAN_SOURCE=man/cppcheck.1.xml


###### Object Files

LIBOBJ =      $(libcppdir)/analyzerinfo.o \
              $(libcppdir)/astutils.o \
              $(libcppdir)/check.o \
              $(libcppdir)/check64bit.o \
              $(libcppdir)/checkassert.o \
              $(libcppdir)/checkautovariables.o \
              $(libcppdir)/checkbool.o \
              $(libcppdir)/checkboost.o \
              $(libcppdir)/checkbufferoverrun.o \
              $(libcppdir)/checkclass.o \
              $(libcppdir)/checkcondition.o \
              $(libcppdir)/checkexceptionsafety.o \
              $(libcppdir)/checkfunctions.o \
              $(libcppdir)/checkinternal.o \
              $(libcppdir)/checkio.o \
              $(libcppdir)/checkleakautovar.o \
              $(libcppdir)/checkmemoryleak.o \
              $(libcppdir)/checknullpointer.o \
              $(libcppdir)/checkother.o \
              $(libcppdir)/checkpostfixoperator.o \
              $(libcppdir)/checksizeof.o \
              $(libcppdir)/checkstl.o \
              $(libcppdir)/checkstring.o \
              $(libcppdir)/checktype.o \
              $(libcppdir)/checkuninitvar.o \
              $(libcppdir)/checkunusedfunctions.o \
              $(libcppdir)/checkunusedvar.o \
              $(libcppdir)/checkvaarg.o \
              $(libcppdir)/clangimport.o \
              $(libcppdir)/cppcheck.o \
              $(libcppdir)/ctu.o \
              $(libcppdir)/errorlogger.o \
              $(libcppdir)/exprengine.o \
              $(libcppdir)/forwardanalyzer.o \
              $(libcppdir)/importproject.o \
              $(libcppdir)/library.o \
              $(libcppdir)/mathlib.o \
              $(libcppdir)/path.o \
              $(libcppdir)/pathanalysis.o \
              $(libcppdir)/pathmatch.o \
              $(libcppdir)/platform.o \
              $(libcppdir)/preprocessor.o \
              $(libcppdir)/programmemory.o \
              $(libcppdir)/settings.o \
              $(libcppdir)/suppressions.o \
              $(libcppdir)/symboldatabase.o \
              $(libcppdir)/templatesimplifier.o \
              $(libcppdir)/timer.o \
              $(libcppdir)/token.o \
              $(libcppdir)/tokenize.o \
              $(libcppdir)/tokenlist.o \
              $(libcppdir)/valueflow.o

EXTOBJ =      externals/simplecpp/simplecpp.o \
              externals/tinyxml/tinyxml2.o

CLIOBJ =      cli/cmdlineparser.o \
              cli/cppcheckexecutor.o \
              cli/filelister.o \
              cli/main.o \
              cli/threadexecutor.o

TESTOBJ =     test/options.o \
              test/test64bit.o \
              test/testassert.o \
              test/testastutils.o \
              test/testautovariables.o \
              test/testbool.o \
              test/testboost.o \
              test/testbufferoverrun.o \
              test/testcharvar.o \
              test/testclangimport.o \
              test/testclass.o \
              test/testcmdlineparser.o \
              test/testcondition.o \
              test/testconstructors.o \
              test/testcppcheck.o \
              test/testerrorlogger.o \
              test/testexceptionsafety.o \
              test/testexprengine.o \
              test/testfilelister.o \
              test/testfunctions.o \
              test/testgarbage.o \
              test/testimportproject.o \
              test/testincompletestatement.o \
              test/testinternal.o \
              test/testio.o \
              test/testleakautovar.o \
              test/testlibrary.o \
              test/testmathlib.o \
              test/testmemleak.o \
              test/testnullpointer.o \
              test/testoptions.o \
              test/testother.o \
              test/testpath.o \
              test/testpathmatch.o \
              test/testplatform.o \
              test/testpostfixoperator.o \
              test/testpreprocessor.o \
              test/testrunner.o \
              test/testsamples.o \
              test/testsimplifytemplate.o \
              test/testsimplifytokens.o \
              test/testsimplifytypedef.o \
              test/testsimplifyusing.o \
              test/testsizeof.o \
              test/teststl.o \
              test/teststring.o \
              test/testsuite.o \
              test/testsuppressions.o \
              test/testsymboldatabase.o \
              test/testthreadexecutor.o \
              test/testtimer.o \
              test/testtoken.o \
              test/testtokenize.o \
              test/testtokenlist.o \
              test/testtype.o \
              test/testuninitvar.o \
              test/testunusedfunctions.o \
              test/testunusedprivfunc.o \
              test/testunusedvar.o \
              test/testutils.o \
              test/testvaarg.o \
              test/testvalueflow.o \
              test/testvarid.o

.PHONY: run-dmake tags


###### Targets

cppcheck: $(LIBOBJ) $(CLIOBJ) $(EXTOBJ)
	$(CXX) $(CPPFLAGS) $(CXXFLAGS) -o $@ $^ $(LIBS) $(LDFLAGS) $(RDYNAMIC)

all:	cppcheck testrunner

testrunner: $(TESTOBJ) $(LIBOBJ) $(EXTOBJ) cli/threadexecutor.o cli/cmdlineparser.o cli/cppcheckexecutor.o cli/filelister.o
	$(CXX) $(CPPFLAGS) $(CXXFLAGS) -o $@ $^ $(LIBS) $(LDFLAGS) $(RDYNAMIC)

test:	all
	./testrunner

check:	all
	./testrunner -q

checkcfg:	cppcheck validateCFG
	./test/cfg/runtests.sh

dmake:	tools/dmake.o cli/filelister.o $(libcppdir)/pathmatch.o $(libcppdir)/path.o externals/simplecpp/simplecpp.o
	$(CXX) $(CXXFLAGS) -o $@ $^ $(LDFLAGS)

run-dmake: dmake
	./dmake

generate_cfg_tests: tools/generate_cfg_tests.o $(EXTOBJ)
	g++ -isystem externals/tinyxml -o generate_cfg_tests tools/generate_cfg_tests.o $(EXTOBJ)
clean:
	rm -f build/*.o lib/*.o cli/*.o test/*.o tools/*.o externals/*/*.o testrunner dmake cppcheck cppcheck.exe cppcheck.1

man:	man/cppcheck.1

man/cppcheck.1:	$(MAN_SOURCE)

	$(XP) $(DB2MAN) $(MAN_SOURCE)

tags:
	ctags -R --exclude=doxyoutput --exclude=test/cfg --exclude=test/synthetic cli externals gui lib test

install: cppcheck
	install -d ${BIN}
	install cppcheck ${BIN}
	install htmlreport/cppcheck-htmlreport ${BIN}
ifdef FILESDIR
	install -d ${DESTDIR}${FILESDIR}
	install -d ${DESTDIR}${FILESDIR}/addons
	install -m 644 addons/*.py ${DESTDIR}${FILESDIR}/addons
	install -d ${DESTDIR}${FILESDIR}/cfg
	install -m 644 cfg/*.cfg ${DESTDIR}${FILESDIR}/cfg
	install -d ${DESTDIR}${FILESDIR}/platforms
	install -m 644 platforms/*.xml ${DESTDIR}${FILESDIR}/platforms
else
	$(error FILESDIR must be set!)
endif

uninstall:
	@if test -d ${BIN}; then \
	  files="cppcheck cppcheck-htmlreport"; \
	  echo '(' cd ${BIN} '&&' rm -f $$files ')'; \
	  ( cd ${BIN} && rm -f $$files ); \
	fi
ifdef FILESDIR 
	@if test -d ${DESTDIR}${FILESDIR}; then \
	  echo rm -rf ${DESTDIR}${FILESDIR}; \
	  rm -rf ${DESTDIR}${FILESDIR}; \
	fi
endif
ifdef CFGDIR 
	@if test -d ${DESTDIR}${CFGDIR}; then \
	  files="`cd cfg 2>/dev/null && ls`"; \
	  if test -n "$$files"; then \
	    echo '(' cd ${DESTDIR}${CFGDIR} '&&' rm -f $$files ')'; \
	    ( cd ${DESTDIR}${CFGDIR} && rm -f $$files ); \
	  fi; \
	fi
endif

# Validation of library files:
ConfigFiles := $(wildcard cfg/*.cfg)
ConfigFilesCHECKED := $(patsubst %.cfg,%.checked,$(ConfigFiles))
.PHONY: validateCFG
%.checked:%.cfg
	xmllint --noout --relaxng cfg/cppcheck-cfg.rng $<
validateCFG: ${ConfigFilesCHECKED}
	xmllint --noout cfg/cppcheck-cfg.rng

# Validation of platforms files:
PlatformFiles := $(wildcard platforms/*.xml)
PlatformFilesCHECKED := $(patsubst %.xml,%.checked,$(PlatformFiles))
.PHONY: validatePlatforms
%.checked:%.xml
	xmllint --noout --relaxng platforms/cppcheck-platforms.rng $<
validatePlatforms: ${PlatformFilesCHECKED}

# Validate XML output (to detect regressions)
/tmp/errorlist.xml: cppcheck
	./cppcheck --errorlist >$@
/tmp/example.xml: cppcheck
	./cppcheck --xml --enable=all --inconclusive --suppress=operatorEqVarError:*check.h --max-configs=1 -j 4 cli externals gui lib test 2>/tmp/example.xml
createXMLExamples:/tmp/errorlist.xml /tmp/example.xml

=== gui/CMakeLists.txt ===
if (BUILD_GUI)

    set(CMAKE_AUTOMOC ON)
    if (CMAKE_BUILD_TYPE MATCHES "Release")
        add_definitions(-DQT_NO_DEBUG)
        add_definitions(-DQT_NO_DEBUG_OUTPUT)
        add_definitions(-DQT_NO_WARNING_OUTPUT)
    else()
        add_definitions(-DQT_DEBUG)
    endif()

    include_directories(${PROJECT_SOURCE_DIR}/lib/)
    include_directories(SYSTEM ${PROJECT_SOURCE_DIR}/externals/tinyxml/)

    file(GLOB hdrs "*.h")
    file(GLOB srcs "*.cpp")
    file(GLOB uis  "*.ui")
    file(GLOB tss  "*.ts")
    QT5_WRAP_UI(uis_hdrs ${uis})
    QT5_ADD_RESOURCES(resources "gui.qrc")
    QT5_ADD_TRANSLATION(qms ${tss})

    add_executable(cppcheck-gui ${hdrs} ${srcs} ${uis_hdrs} ${resources} ${qms} $<TARGET_OBJECTS:lib_objs> $<TARGET_OBJECTS:tinyxml_objs> $<TARGET_OBJECTS:simplecpp_objs>)
    if (HAVE_RULES)
        target_link_libraries(cppcheck-gui pcre)
    endif()
    target_link_libraries(cppcheck-gui Qt5::Core Qt5::Gui Qt5::Widgets Qt5::PrintSupport)
    if(WITH_QCHART)
        target_compile_definitions (cppcheck-gui PRIVATE HAVE_QCHART )
        target_link_libraries(cppcheck-gui Qt5::Charts)
    endif()
    if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
        if (NOT CMAKE_CXX_COMPILER_VERSION VERSION_LESS "8.0.0")
            # Q_UNUSED() in generated code
            target_compile_options(cppcheck-gui PRIVATE -Wno-extra-semi-stmt)
        endif()
    endif()

    install(TARGETS cppcheck-gui RUNTIME DESTINATION ${CMAKE_INSTALL_FULL_BINDIR} COMPONENT applications)
    install(FILES ${qms} DESTINATION ${CMAKE_INSTALL_FULL_BINDIR} COMPONENT applications)

    install(FILES cppcheck-gui.desktop DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/applications)

    # icons
    install(FILES cppcheck-gui.svg DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/scalable/apps)
    install(FILES cppcheck-gui.png DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/64x64/apps)

    set(CMAKE_AUTOMOC OFF)

endif()

=== lib/CMakeLists.txt ===
include_directories(SYSTEM ${PROJECT_SOURCE_DIR}/externals/)
include_directories(SYSTEM ${PROJECT_SOURCE_DIR}/externals/tinyxml/)
include_directories(${PROJECT_SOURCE_DIR}/externals/simplecpp/)

file(GLOB_RECURSE hdrs "*.h")
file(GLOB_RECURSE srcs "*.cpp")

function(build_src output filename)
    get_filename_component(file ${filename} NAME)
    set(outfile ${CMAKE_CURRENT_BINARY_DIR}/build/mc_${file})
    set(${output} ${${output}} ${outfile} PARENT_SCOPE)
    if (USE_MATCHCOMPILER MATCHES "Verify")
        set(verify_option "--verify")
    endif()
    add_custom_command(
        OUTPUT ${outfile}
        COMMAND ${PYTHON_EXECUTABLE} "${PROJECT_SOURCE_DIR}/tools/matchcompiler.py" 
                --read-dir="${CMAKE_CURRENT_SOURCE_DIR}" 
                --prefix="mc_" 
                --line 
                ${verify_option} 
                ${file}
        DEPENDS ${file} 
        DEPENDS ${PROJECT_SOURCE_DIR}/tools/matchcompiler.py
    )
    set_source_files_properties(${outfile} PROPERTIES GENERATED TRUE)
endfunction()

foreach(file ${srcs})
    build_src(srcs_build ${file})
endforeach()

if (NOT USE_MATCHCOMPILER_OPT MATCHES "Off")
    set(srcs_lib ${srcs_build})
else()
    set(srcs_lib ${srcs})
endif()

add_library(lib_objs OBJECT ${srcs_lib} ${hdrs})
if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    add_library(lib_objs_sanitized OBJECT EXCLUDE_FROM_ALL ${srcs_lib} ${hdrs})
    target_compile_options(lib_objs_sanitized PRIVATE -fsanitize=address)
endif()

=== oss-fuzz/CMakeLists.txt ===
if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    add_executable(fuzz-client EXCLUDE_FROM_ALL
            main.cpp
            type2.cpp
            $<TARGET_OBJECTS:simplecpp_objs_sanitized>
            $<TARGET_OBJECTS:tinyxml_objs_sanitized>
            $<TARGET_OBJECTS:lib_objs_sanitized>)
    target_include_directories(fuzz-client PRIVATE ${CMAKE_SOURCE_DIR}/lib ${CMAKE_SOURCE_DIR}/externals/simplecpp ${CMAKE_SOURCE_DIR}/externals/tinyxml ${CMAKE_SOURCE_DIR}/externals)
    target_compile_options(fuzz-client PRIVATE -fsanitize=fuzzer)
    # requires CMake >= 3.13
    #target_link_options(fuzz-client PRIVATE -fsanitize=address -fsanitize=fuzzer)
    target_link_libraries(fuzz-client PRIVATE -fsanitize=address -fsanitize=fuzzer)

    add_executable(translate EXCLUDE_FROM_ALL
            translate.cpp
            type2.cpp)
endif()

=== test/CMakeLists.txt ===
if (BUILD_TESTS)

    cmake_minimum_required(VERSION 3.4) # cmake_policy(SET CMP0064 NEW)
    cmake_policy(SET CMP0064 NEW)
    cmake_policy(SET CMP0057 NEW)

    include(CTest)

    find_package(Threads REQUIRED)
    include(ProcessorCount)
    ProcessorCount(N)
    set(CTEST_PARALLEL_LEVEL ${N} CACHE STRING "CTest parallel level")
    add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND} --output-on-failure -j ${CTEST_PARALLEL_LEVEL} -C ${CMAKE_CFG_INTDIR} --timeout 90)

    include_directories(${PROJECT_SOURCE_DIR}/lib/ ${PROJECT_SOURCE_DIR}/cli/)
    include_directories(SYSTEM ${PROJECT_SOURCE_DIR}/externals/tinyxml)
    include_directories(${PROJECT_SOURCE_DIR}/externals/simplecpp/)

    file(GLOB hdrs "*.h")
    file(GLOB srcs "*.cpp")

    add_executable(testrunner ${hdrs} ${srcs} $<TARGET_OBJECTS:lib_objs> $<TARGET_OBJECTS:cli_objs> $<TARGET_OBJECTS:tinyxml_objs> $<TARGET_OBJECTS:simplecpp_objs>)
    if (HAVE_RULES)
        target_link_libraries(testrunner pcre)
    endif()

    add_custom_target(copy_cfg ALL
        COMMENT "Copying cfg files")
    add_custom_command(
        TARGET copy_cfg
        COMMAND ${CMAKE_COMMAND} -E copy_directory "${PROJECT_SOURCE_DIR}/cfg"
            "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/cfg")

    if (WIN32 AND NOT BORLAND)
        target_link_libraries(testrunner Shlwapi.lib)
    endif()

    add_dependencies(testrunner copy_cfg)
    add_dependencies(check testrunner cppcheck)

    set(SKIP_TESTS "" CACHE STRING "A list of tests to skip")

    function(add_fixture NAME)
        set(options)
        set(oneValueArgs WORKING_DIRECTORY)
        set(multiValueArgs)

        cmake_parse_arguments(PARSE "${options}" "${oneValueArgs}" "${multiValueArgs}" ${ARGN})

        if (${NAME} IN_LIST SKIP_TESTS)
        elseif(TEST ${NAME})
        else()
            set(WORKING_DIRECTORY ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
            if (PARSE_WORKING_DIRECTORY)
                set(WORKING_DIRECTORY ${PARSE_WORKING_DIRECTORY})
            endif()
            add_test(NAME ${NAME} COMMAND testrunner ${NAME} WORKING_DIRECTORY ${WORKING_DIRECTORY})
        endif()
    endfunction()

    function(fixture_cost NAME COST)
        if(TEST ${NAME})
            set_tests_properties(${NAME} PROPERTIES COST ${COST})
        endif()
    endfunction()

    add_fixture(TestSamples WORKING_DIRECTORY ${PROJECT_SOURCE_DIR})
    foreach(SRC ${srcs})
        file(STRINGS ${SRC} FIXTURE_LINE REGEX "TestFixture\\(" LIMIT_COUNT 1)
        if(FIXTURE_LINE MATCHES "TestFixture\\(\"([a-zA-z0-9]+)\"\\)")
            add_fixture(${CMAKE_MATCH_1})
        endif()
    endforeach()
    add_fixture(TestLeakAutoVarStrcpy)
    add_fixture(TestLeakAutoVarWindows)
    add_fixture(TestMemleakInFunction)
    add_fixture(TestMemleakInClass)
    add_fixture(TestMemleakStructMember)
    add_fixture(TestMemleakNoVar)

    function(add_cfg CFG_TEST)
        set(options INCONCLUSIVE)
        set(oneValueArgs PLATFORM NAME)
        set(multiValueArgs LIBRARY)

        cmake_parse_arguments(PARSE "${options}" "${oneValueArgs}" "${multiValueArgs}" ${ARGN})
        if(PARSE_LIBRARY)
            string(REPLACE ";" "," LIBRARY "${PARSE_LIBRARY}")
        else()
            get_filename_component(LIBRARY ${CFG_TEST} NAME_WE)
        endif()
        set(PLATFORM unix64)
        if(PARSE_PLATFORM)
            set(PLATFORM ${PARSE_PLATFORM})
        endif()
        if(PARSE_NAME)
            set(TEST_NAME ${PARSE_NAME})
        else()
            string(MAKE_C_IDENTIFIER ${CFG_TEST} TEST_NAME)
        endif()
        set(INCONCLUSIVE)
        if(PARSE_INCONCLUSIVE)
            set(INCONCLUSIVE "--inconclusive")
        endif()
        if (${TEST_NAME} IN_LIST SKIP_TESTS)
        else()
            add_test(NAME cfg-${TEST_NAME} 
                    COMMAND $<TARGET_FILE:cppcheck>
                    --check-library
                    --platform=${PLATFORM}
                    --library=${LIBRARY}
                    --enable=information
                    --enable=style
                    --error-exitcode=1
                    --suppress=missingIncludeSystem
                    --inline-suppr 
                    ${INCONCLUSIVE}
                    ${CMAKE_CURRENT_SOURCE_DIR}/cfg/${CFG_TEST}
            )
        endif()
    endfunction()
    add_cfg(boost.cpp INCONCLUSIVE)
    add_cfg(bsd.c)
    add_cfg(gnu.c LIBRARY posix gnu)
    add_cfg(googletest.cpp)
    add_cfg(gtk.c INCONCLUSIVE)
    add_cfg(libcurl.c)
    add_cfg(lua.c)
    add_cfg(openmp.c)
    add_cfg(posix.c)
    add_cfg(python.c)
    add_cfg(qt.cpp)
    add_cfg(sqlite3.c INCONCLUSIVE)
    add_cfg(std.c INCONCLUSIVE)
    add_cfg(std.cpp INCONCLUSIVE)
    add_cfg(windows.cpp INCONCLUSIVE NAME windows32A PLATFORM win32A)
    add_cfg(windows.cpp INCONCLUSIVE NAME windows32W PLATFORM win32W)
    add_cfg(windows.cpp INCONCLUSIVE NAME windows64 PLATFORM win64)
    add_cfg(wxwidgets.cpp INCONCLUSIVE)

    # Set cost of the more expensive tests to help improve parallel scheduling
    # of tests
    fixture_cost(TestIO 20)
    fixture_cost(cfg-std_c 8)
    fixture_cost(TestThreadExecutor 5)
    fixture_cost(TestLeakAutoVar 4)
    fixture_cost(TestTokenizer 4)
endif()

=== externals/tinyxml/CMakeLists.txt ===
file(GLOB hdrs "*.h")
file(GLOB srcs "*.cpp")

add_library(tinyxml_objs OBJECT ${srcs} ${hdrs})

# TODO: need to be fixed upstream
if (CMAKE_CXX_COMPILER_ID MATCHES "GNU")
    target_compile_options(tinyxml_objs PRIVATE -Wno-suggest-attribute=format)
endif()
if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    if (NOT CMAKE_CXX_COMPILER_VERSION VERSION_LESS "8.0.0")
        target_compile_options(tinyxml_objs PRIVATE -Wno-extra-semi-stmt)
    endif()
endif()

# TODO: conflicts with ANALYZE_* options
if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    add_library(tinyxml_objs_sanitized OBJECT EXCLUDE_FROM_ALL ${srcs} ${hdrs})
    target_compile_options(tinyxml_objs_sanitized PRIVATE -fsanitize=address)
    if (NOT CMAKE_CXX_COMPILER_VERSION VERSION_LESS "8.0.0")
        target_compile_options(tinyxml_objs_sanitized PRIVATE -Wno-extra-semi-stmt)
    endif()
endif()

=== debian/changelog ===
cppcheck (2.0-3) unstable; urgency=medium

  * Add patch fix-pythonhome (Closes: #961925).
  * Remove gdb from Build-Depends (unclear why it existed).
  * Fix lintian override for extra-license-file.
  * Set upstream metadata fields: Bug-Database, Repository, Repository-Browse
  * Add Vcs-* fields to debian/control.

 -- Joachim Reichel <reichel@debian.org>  Wed, 20 May 2020 21:21:17 +0200

cppcheck (2.0-2) unstable; urgency=medium

  * Upload to unstable.

 -- Joachim Reichel <reichel@debian.org>  Wed, 20 May 2020 20:50:52 +0200

cppcheck (2.0-1) experimental; urgency=medium

  * New upstream release.
    - Remove patch adjust-warnings (applied upstream).
    - Update patch fix-default-settings.
    - Add patch fix-cmake.

 -- Joachim Reichel <reichel@debian.org>  Wed, 13 May 2020 18:22:43 +0200

=== debian/control ===
Source: cppcheck
Section: devel
Priority: optional
Maintainer: Joachim Reichel <reichel@debian.org>
Build-Depends:
  cmake,
  debhelper-compat (= 12),
  dh-python,
  dh-sequence-python3,
  docbook-xml,
  docbook-xsl,
  dpkg-dev (>= 1.15.7~),
  libpcre3-dev,
  libqt5charts5-dev,
  libtinyxml2-dev (>= 6.2.0+dfsg),
  python3-all,
  qt5-qmake,
  qtbase5-dev,
  qtbase5-dev-tools,
  qttools5-dev,
  xsltproc
Standards-Version: 4.5.0
Rules-Requires-Root: no
Homepage: http://sourceforge.net/p/cppcheck/wiki/Home/
Vcs-Git: https://salsa.debian.org/reichel/cppcheck.git
Vcs-Browser: https://salsa.debian.org/reichel/cppcheck

Package: cppcheck
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}, python3-pygments
Suggests: cppcheck-gui
Description: tool for static C/C++ code analysis (CLI)
 Cppcheck is a command-line tool that tries to detect bugs that your
 C/C++ compiler doesn't see. It is versatile, and can check non-standard
 code including various compiler extensions, inline assembly code, etc.
 Its internal preprocessor can handle includes, macros, and several
 preprocessor commands. While Cppcheck is highly configurable,
 you can start using it just by giving it a path to the source code.
 .
 It includes checks for:
  * pointers to out-of-scope auto variables;
  * assignment of auto variables to an effective parameter of a function;
  * out-of-bounds errors in arrays and STL;
  * missing class constructors;
  * variables not initialized by a constructor;
  * use of memset, memcpy, etcetera on a class;
  * non-virtual destructors for base classes;
  * operator= not returning a constant reference to itself;
  * use of deprecated functions (mktemp, gets, scanf);
  * exceptions thrown in destructors;
  * memory leaks in class or function variables;
  * C-style pointer cast in C++ code;
  * redundant if;
  * misuse of the strtol or sprintf functions;
  * unsigned division or division by zero;
  * unused functions and struct members;
  * passing parameters by value;
  * misuse of signed char variables;
  * unusual pointer arithmetic (such as "abc" + 'd');
  * dereferenced null pointers;
  * incomplete statements;
  * misuse of iterators when iterating through a container;
  * dereferencing of erased iterators;
  * use of invalidated vector iterators/pointers;
 .
 This package contains the command-line interface for cppcheck.

Package: cppcheck-gui
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, cppcheck (= ${binary:Version})
Suggests: python3, clang
Description: tool for static C/C++ code analysis (GUI)
 Cppcheck is a command-line tool that tries to detect bugs that your
 C/C++ compiler doesn't see. It is versatile, and can check non-standard
 code including various compiler extensions, inline assembly code, etc.
 Its internal preprocessor can handle includes, macros, and several
 preprocessor commands. While Cppcheck is highly configurable,
 you can start using it just by giving it a path to the source code.
 .
 It includes checks for:
  * pointers to out-of-scope auto variables;
  * assignment of auto variables to an effective parameter of a function;
  * out-of-bounds errors in arrays and STL;
  * missing class constructors;
  * variables not initialized by a constructor;
  * use of memset, memcpy, etcetera on a class;
  * non-virtual destructors for base classes;
  * operator= not returning a constant reference to itself;
  * use of deprecated functions (mktemp, gets, scanf);
  * exceptions thrown in destructors;
  * memory leaks in class or function variables;
  * C-style pointer cast in C++ code;
  * redundant if;
  * misuse of the strtol or sprintf functions;
  * unsigned division or division by zero;
  * unused functions and struct members;
  * passing parameters by value;
  * misuse of signed char variables;
  * unusual pointer arithmetic (such as "abc" + 'd');
  * dereferenced null pointers;
  * incomplete statements;
  * misuse of iterators when iterating through a container;
  * dereferencing of erased iterators;
  * use of invalidated vector iterators/pointers
 .
 This package contains the graphical user interface for cppcheck.

## cppcheck 2.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -28,9 +28,10 @@
 add_subdirectory(lib)   # CppCheck Library 
 add_subdirectory(cli)   # Client application
 add_subdirectory(test)  # Tests
-ADD_SUBDIRECTORY(gui)   # Graphical application
-ADD_SUBDIRECTORY(tools/triage)   # Triage tool
+add_subdirectory(gui)   # Graphical application
+add_subdirectory(tools/triage)   # Triage tool
 add_subdirectory(oss-fuzz) # OSS-Fuzz clients
+add_subdirectory(tools)
 
 include(cmake/printInfo.cmake)
 include(cmake/clang_tidy.cmake)

=== Makefile ===
--- 
+++ 
@@ -188,6 +188,7 @@
               $(libcppdir)/cppcheck.o \
               $(libcppdir)/ctu.o \
               $(libcppdir)/errorlogger.o \
+              $(libcppdir)/errortypes.o \
               $(libcppdir)/exprengine.o \
               $(libcppdir)/forwardanalyzer.o \
               $(libcppdir)/importproject.o \
@@ -207,6 +208,7 @@
               $(libcppdir)/token.o \
               $(libcppdir)/tokenize.o \
               $(libcppdir)/tokenlist.o \
+              $(libcppdir)/utils.o \
               $(libcppdir)/valueflow.o
 
 EXTOBJ =      externals/simplecpp/simplecpp.o \
@@ -304,7 +306,7 @@
 checkcfg:	cppcheck validateCFG
 	./test/cfg/runtests.sh
 
-dmake:	tools/dmake.o cli/filelister.o $(libcppdir)/pathmatch.o $(libcppdir)/path.o externals/simplecpp/simplecpp.o
+dmake:	tools/dmake.o cli/filelister.o $(libcppdir)/pathmatch.o $(libcppdir)/path.o $(libcppdir)/utils.o externals/simplecpp/simplecpp.o
 	$(CXX) $(CXXFLAGS) -o $@ $^ $(LDFLAGS)
 
 run-dmake: dmake
@@ -383,5 +385,4 @@
 /tmp/errorlist.xml: cppcheck
 	./cppcheck --errorlist >$@
 /tmp/example.xml: cppcheck
-	./cppcheck --xml --enable=all --inconclusive --suppress=operatorEqVarError:*check.h --max-configs=1 -j 4 cli externals gui lib test 2>/tmp/example.xml
-createXMLExamples:/tmp/errorlist.xml /tmp/example.xml
+	./cppcheck --xml --enable=all --inconclusive --max-configs=1 samples 2>/tmp/example.xml

=== cli/CMakeLists.txt ===
include_directories(${PROJECT_SOURCE_DIR}/lib/)
include_directories(SYSTEM ${PROJECT_SOURCE_DIR}/externals/tinyxml/)
include_directories(${PROJECT_SOURCE_DIR}/externals/simplecpp/)

file(GLOB hdrs "*.h")
file(GLOB srcs "*.cpp")
file(GLOB mainfile "main.cpp")
list(REMOVE_ITEM srcs ${mainfile})

add_library(cli_objs OBJECT ${hdrs} ${srcs}) 
add_executable(cppcheck ${hdrs} ${mainfile} $<TARGET_OBJECTS:cli_objs> $<TARGET_OBJECTS:lib_objs> $<TARGET_OBJECTS:tinyxml_objs> $<TARGET_OBJECTS:simplecpp_objs>)
if (HAVE_RULES)
    target_link_libraries(cppcheck ${PCRE_LIBRARY})
endif()
if (USE_Z3)
    target_link_libraries(cppcheck ${Z3_LIBRARIES})
endif()
if (WIN32 AND NOT BORLAND)
    target_link_libraries(cppcheck Shlwapi.lib)
endif()

install(TARGETS cppcheck
    RUNTIME DESTINATION ${CMAKE_INSTALL_FULL_BINDIR}
    COMPONENT applications)

install(FILES ${addons}
   DESTINATION ${FILESDIR}/addons
   COMPONENT headers)

install(FILES ${cfgs}
   DESTINATION ${FILESDIR}/cfg
   COMPONENT headers)

install(FILES ${platforms}
   DESTINATION ${FILESDIR}/platforms
   COMPONENT headers)

=== gui/CMakeLists.txt ===
--- 
+++ 
@@ -22,7 +22,10 @@
 
     add_executable(cppcheck-gui ${hdrs} ${srcs} ${uis_hdrs} ${resources} ${qms} $<TARGET_OBJECTS:lib_objs> $<TARGET_OBJECTS:tinyxml_objs> $<TARGET_OBJECTS:simplecpp_objs>)
     if (HAVE_RULES)
-        target_link_libraries(cppcheck-gui pcre)
+        target_link_libraries(cppcheck-gui ${PCRE_LIBRARY})
+    endif()
+    if (USE_Z3)
+        target_link_libraries(cppcheck-gui ${Z3_LIBRARIES})
     endif()
     target_link_libraries(cppcheck-gui Qt5::Core Qt5::Gui Qt5::Widgets Qt5::PrintSupport)
     if(WITH_QCHART)

=== lib/CMakeLists.txt ===
--- 
+++ 
@@ -37,7 +37,7 @@
 endif()
 
 add_library(lib_objs OBJECT ${srcs_lib} ${hdrs})
-if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
+if (ENABLE_OSS_FUZZ AND CMAKE_CXX_COMPILER_ID MATCHES "Clang")
     add_library(lib_objs_sanitized OBJECT EXCLUDE_FROM_ALL ${srcs_lib} ${hdrs})
     target_compile_options(lib_objs_sanitized PRIVATE -fsanitize=address)
 endif()

=== oss-fuzz/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
+if (ENABLE_OSS_FUZZ AND CMAKE_CXX_COMPILER_ID MATCHES "Clang")
     add_executable(fuzz-client EXCLUDE_FROM_ALL
             main.cpp
             type2.cpp

=== oss-fuzz/Makefile ===
#
# fuzzer clients
# ====================
#
# Local libfuzzer client:
# make CXX=clang++-6.0 CXXFLAGS="-fsanitize=address" fuzz-client

CPPCHECK_DIR=..
INCLUDE_DIR=-I ${CPPCHECK_DIR}/lib -I ${CPPCHECK_DIR}/externals/simplecpp -I ${CPPCHECK_DIR}/externals/tinyxml -I ${CPPCHECK_DIR}/externals
SRC_FILES=main.cpp type2.cpp ${CPPCHECK_DIR}/externals/simplecpp/simplecpp.cpp ${CPPCHECK_DIR}/externals/tinyxml/tinyxml2.cpp ${CPPCHECK_DIR}/lib/*.cpp

all:	oss-fuzz-client	translate

oss-fuzz-client:	main.cpp	type2.cpp	type2.h
	${CXX} -std=c++11 -g ${CXXFLAGS} -o oss-fuzz-client ${INCLUDE_DIR} ${SRC_FILES} ${LIB_FUZZING_ENGINE}

fuzz-client:	main.cpp	type2.cpp	type2.h
	${CXX} -std=c++11 -g ${CXXFLAGS} -o fuzz-client ${INCLUDE_DIR} ${SRC_FILES} -fsanitize=fuzzer

translate:	translate.cpp	type2.cpp	type2.h
	${CXX} -std=c++11 -g ${CXXFLAGS} -o translate type2.cpp translate.cpp

clean:
	rm -f oss-fuzz-client fuzz-client translate

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -21,7 +21,10 @@
 
     add_executable(testrunner ${hdrs} ${srcs} $<TARGET_OBJECTS:lib_objs> $<TARGET_OBJECTS:cli_objs> $<TARGET_OBJECTS:tinyxml_objs> $<TARGET_OBJECTS:simplecpp_objs>)
     if (HAVE_RULES)
-        target_link_libraries(testrunner pcre)
+        target_link_libraries(testrunner ${PCRE_LIBRARY})
+    endif()
+    if (USE_Z3)
+        target_link_libraries(testrunner ${Z3_LIBRARIES})
     endif()
 
     add_custom_target(copy_cfg ALL

=== externals/simplecpp/CMakeLists.txt ===
file(GLOB hdrs "*.h")
file(GLOB srcs "*.cpp")

add_library(simplecpp_objs OBJECT ${srcs} ${hdrs})
# TODO: conflicts with ANALYZE_* options
if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    add_library(simplecpp_objs_sanitized OBJECT EXCLUDE_FROM_ALL ${srcs} ${hdrs})
    target_compile_options(simplecpp_objs_sanitized PRIVATE -fsanitize=address)
endif()

=== externals/tinyxml/CMakeLists.txt ===
--- 
+++ 
@@ -14,7 +14,7 @@
 endif()
 
 # TODO: conflicts with ANALYZE_* options
-if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
+if (ENABLE_OSS_FUZZ AND CMAKE_CXX_COMPILER_ID MATCHES "Clang")
     add_library(tinyxml_objs_sanitized OBJECT EXCLUDE_FROM_ALL ${srcs} ${hdrs})
     target_compile_options(tinyxml_objs_sanitized PRIVATE -fsanitize=address)
     if (NOT CMAKE_CXX_COMPILER_VERSION VERSION_LESS "8.0.0")

=== debian/changelog ===
cppcheck (2.1-1) unstable; urgency=medium

  * New upstream release.
    - Remove patch fix-cmake (applied upstream).
    - Remove patch fix-pythonhome (superseded upstream).
    - Update patch fix-default-settings.
    - Add patch fix-y2038.

 -- Joachim Reichel <reichel@debian.org>  Thu, 18 Jun 2020 18:54:23 +0200

## cppcheck 2.2

=== Makefile ===
--- 
+++ 
@@ -158,6 +158,7 @@
 
 LIBOBJ =      $(libcppdir)/analyzerinfo.o \
               $(libcppdir)/astutils.o \
+              $(libcppdir)/bughuntingchecks.o \
               $(libcppdir)/check.o \
               $(libcppdir)/check64bit.o \
               $(libcppdir)/checkassert.o \
@@ -228,6 +229,7 @@
               test/testbool.o \
               test/testboost.o \
               test/testbufferoverrun.o \
+              test/testbughuntingchecks.o \
               test/testcharvar.o \
               test/testclangimport.o \
               test/testclass.o \
@@ -385,4 +387,3 @@
 /tmp/errorlist.xml: cppcheck
 	./cppcheck --errorlist >$@
 /tmp/example.xml: cppcheck
-	./cppcheck --xml --enable=all --inconclusive --max-configs=1 samples 2>/tmp/example.xml

=== gui/CMakeLists.txt ===
--- 
+++ 
@@ -27,7 +27,7 @@
     if (USE_Z3)
         target_link_libraries(cppcheck-gui ${Z3_LIBRARIES})
     endif()
-    target_link_libraries(cppcheck-gui Qt5::Core Qt5::Gui Qt5::Widgets Qt5::PrintSupport)
+    target_link_libraries(cppcheck-gui Qt5::Core Qt5::Gui Qt5::Widgets Qt5::PrintSupport Qt5::Help)
     if(WITH_QCHART)
         target_compile_definitions (cppcheck-gui PRIVATE HAVE_QCHART )
         target_link_libraries(cppcheck-gui Qt5::Charts)

=== lib/CMakeLists.txt ===
--- 
+++ 
@@ -37,7 +37,13 @@
 endif()
 
 add_library(lib_objs OBJECT ${srcs_lib} ${hdrs})
+if (NOT CMAKE_DISABLE_PRECOMPILE_HEADERS)
+    target_precompile_headers(lib_objs PRIVATE precompiled.h)
+endif()
 if (ENABLE_OSS_FUZZ AND CMAKE_CXX_COMPILER_ID MATCHES "Clang")
     add_library(lib_objs_sanitized OBJECT EXCLUDE_FROM_ALL ${srcs_lib} ${hdrs})
     target_compile_options(lib_objs_sanitized PRIVATE -fsanitize=address)
+    if (NOT CMAKE_DISABLE_PRECOMPILE_HEADERS)
+        target_precompile_headers(lib_objs_sanitized PRIVATE precompiled.h)
+    endif()
 endif()

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -25,6 +25,10 @@
     endif()
     if (USE_Z3)
         target_link_libraries(testrunner ${Z3_LIBRARIES})
+    endif()
+
+    if (NOT CMAKE_DISABLE_PRECOMPILE_HEADERS)
+        target_precompile_headers(testrunner PRIVATE precompiled.h)
     endif()
 
     add_custom_target(copy_cfg ALL

=== debian/changelog ===
cppcheck (2.2-1) unstable; urgency=medium

  * New upstream release (Closes: #966386).
  * Add Suggests: clang to cppcheck, and Suggests: clang-tidy to cppcheck
    and cppcheck-gui.
  * Remove patch fix-y2038 (superseded upstream).
  * Update patch fix-translation-loading.

 -- Joachim Reichel <reichel@debian.org>  Sun, 11 Oct 2020 17:42:26 +0200

=== debian/control ===
--- 
+++ 
@@ -28,7 +28,7 @@
 Package: cppcheck
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}, python3-pygments
-Suggests: cppcheck-gui
+Suggests: cppcheck-gui, clang, clang-tidy
 Description: tool for static C/C++ code analysis (CLI)
  Cppcheck is a command-line tool that tries to detect bugs that your
  C/C++ compiler doesn't see. It is versatile, and can check non-standard
@@ -68,7 +68,7 @@
 Package: cppcheck-gui
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, cppcheck (= ${binary:Version})
-Suggests: python3, clang
+Suggests: python3, clang, clang-tidy
 Description: tool for static C/C++ code analysis (GUI)
  Cppcheck is a command-line tool that tries to detect bugs that your
  C/C++ compiler doesn't see. It is versatile, and can check non-standard
